searchNodes=[{"doc":"New Relic Agent - Public API","ref":"NewRelic.html","title":"NewRelic","type":"module"},{"doc":"Report custom attributes on the current Transaction Reporting nested data structures is supported by auto-flattening them into a list of key-value pairs. NewRelic.add_attributes(foo: &quot;bar&quot;) # &quot;foo&quot; =&gt; &quot;bar&quot; NewRelic.add_attributes(map: %{foo: &quot;bar&quot;, baz: &quot;qux&quot;}) # &quot;map.foo&quot; =&gt; &quot;bar&quot; # &quot;map.baz&quot; =&gt; &quot;qux&quot; # &quot;map.size&quot; =&gt; 2 NewRelic.add_attributes(list: [&quot;a&quot;, &quot;b&quot;, &quot;c&quot;]) # &quot;list.0&quot; =&gt; &quot;a&quot; # &quot;list.1&quot; =&gt; &quot;b&quot; # &quot;list.2&quot; =&gt; &quot;c&quot; # &quot;list.length&quot; =&gt; 3 Notes: Nested Lists and Maps are truncated at 10 items since there are a limited number of attributes that can be reported on Transaction events","ref":"NewRelic.html#add_attributes/1","title":"NewRelic.add_attributes/1","type":"function"},{"doc":"Deprecated, please use distributed_trace_headers","ref":"NewRelic.html#create_distributed_trace_payload/1","title":"NewRelic.create_distributed_trace_payload/1","type":"function"},{"doc":"You must manually instrument outgoing HTTP calls to connect them to a Distributed Trace. The agent will automatically read request headers and detect if the request is a part of a Distributed Trace, but outgoing requests need an extra header: HTTPoison.get(url, [&quot;x-api-key&quot;: &quot;secret&quot;] ++ NewRelic.distributed_trace_headers(:http)) Notes: Call NewRelic.distributed_trace_headers immediately before making the request since calling the function marks the &quot;start&quot; time of the request.","ref":"NewRelic.html#distributed_trace_headers/1","title":"NewRelic.distributed_trace_headers/1","type":"function"},{"doc":"Call within a transaction to prevent it from reporting. def index(conn, %{}) do NewRelic.ignore_transaction() send_resp(conn, :ok, &#39;&#39;) end","ref":"NewRelic.html#ignore_transaction/0","title":"NewRelic.ignore_transaction/0","type":"function"},{"doc":"Report a Custom event to NRDB. NewRelic.report_custom_event(&quot;EventType&quot;, %{&quot;foo&quot; =&gt; &quot;bar&quot;})","ref":"NewRelic.html#report_custom_event/2","title":"NewRelic.report_custom_event/2","type":"function"},{"doc":"To get detailed information about a particular process, you can install a Process sampler. You must tell the Agent about your process from within the process. For a GenServer, this function call should be made in the init function: defmodule ImportantProcess do use GenServer def init(:ok) do NewRelic.sample_process {:ok, %{}} end end Once installed, the agent will report ElixirSample events with: category = &quot;Process&quot; message_queue_length reductions memory_kb","ref":"NewRelic.html#sample_process/0","title":"NewRelic.sample_process/0","type":"function"},{"doc":"Store information about the type of work the current span is doing. Options: :generic, custom: attributes :http, url: url, method: method, component: component :datastore, statement: statement, instance: instance, address: address, hostname: hostname, component: component","ref":"NewRelic.html#set_span/2","title":"NewRelic.set_span/2","type":"function"},{"doc":"Set the name of the current transaction. The first segment will be treated as the Transaction namespace, and commonly contains the name of the framework. Notes: At least 2 segments are required to light up the Transactions UI in APM In the following example, you will see /custom/transaction/name in the Transaction list. NewRelic.set_transaction_name(&quot;/Plug/custom/transaction/name&quot;)","ref":"NewRelic.html#set_transaction_name/1","title":"NewRelic.set_transaction_name/1","type":"function"},{"doc":"Start a new &quot;Other&quot; Transaction. This will begin monitoring the current process as an &quot;Other&quot; Transaction (ie: Not a &quot;Web&quot; Transaction). The first argument will be considered the &quot;category&quot;, the second is the &quot;name&quot;. Examples: NewRelic.start_transaction(&quot;GenStage&quot;, &quot;MyConsumer/EventType&quot;) NewRelic.start_transaction(&quot;Task&quot;, &quot;TaskName&quot;) Notes: Don&#39;t use this to track Web Transactions - for that, use NewRelic.Transaction in your Plug pipeline so that we can properly categorize as Web Transactions in the UI. Do not use this for processes that live a very long time, doing so will risk a memory leak tracking attributes in the transaction! You can&#39;t start a new transaction within an existing one. Any process spawned inside a transaction belongs to that transaction. If multiple transactions are started in the same Process, you must call NewRelic.stop_transaction() to mark the end of the transaction.","ref":"NewRelic.html#start_transaction/2","title":"NewRelic.start_transaction/2","type":"function"},{"doc":"Stop an &quot;Other&quot; Transaction. If multiple transactions are started in the same Process, you must call NewRelic.stop_transaction() to mark the end of the transaction.","ref":"NewRelic.html#stop_transaction/0","title":"NewRelic.stop_transaction/0","type":"function"},{"doc":"New Relic Agent Configuration All configuration items can be set via ENV variable or via Application config","ref":"NewRelic.Config.html","title":"NewRelic.Config","type":"module"},{"doc":"Configure your application name. Required May contain up to 3 names seperated by ;","ref":"NewRelic.Config.html#app_name/0","title":"NewRelic.Config.app_name/0","type":"function"},{"doc":"An optional list of key/value pairs that will be automatic custom attributes on all event types reported (Transactions, etc). Options: {:system, &quot;ENV_NAME&quot;} Read a System ENV variable {module, function, args} Call a function. Warning: Be very careful, this will get called a lot! &quot;foo&quot; A direct value Example: config :new_relic_agent, automatic_attributes: [ environment: {:system, &quot;APP_ENV&quot;}, node_name: {Node, :self, []}, team_name: &quot;Afterlife&quot; ]","ref":"NewRelic.Config.html#automatic_attributes/0","title":"NewRelic.Config.automatic_attributes/0","type":"function"},{"doc":"","ref":"NewRelic.Config.html#event_harvest_config/0","title":"NewRelic.Config.event_harvest_config/0","type":"function"},{"doc":"Some Agent features can be controlled via configuration :error_collector_enabled (default true) Controls collecting any Error traces or metrics :sql_collection_enabled (default true) Controls collection of SQL query strings :ecto_instrumentation_enabled (default true) Controls all Ecto instrumentation function_argument_collection_enabled (default true) Controls collection of traced function arguments","ref":"NewRelic.Config.html#feature?/1","title":"NewRelic.Config.feature?/1","type":"function"},{"doc":"Configure the host to report to. Most customers have no need to set this.","ref":"NewRelic.Config.html#host/0","title":"NewRelic.Config.host/0","type":"function"},{"doc":"An optional list of labels that will be applied to the application. Configured with a single string containing a list of key-value pairs: key1:value1;key2:value2 The delimiting characters ; and : are not allowed in the key or value Example: config :new_relic_agent, labels: &quot;region:west;env:prod&quot;","ref":"NewRelic.Config.html#labels/0","title":"NewRelic.Config.labels/0","type":"function"},{"doc":"Configure your New Relic License Key. Required","ref":"NewRelic.Config.html#license_key/0","title":"NewRelic.Config.license_key/0","type":"function"},{"doc":"Configure the Agent logging mechanism. Defaults to &quot;tmp/new_relic.log&quot;. Options: &quot;stdout&quot; &quot;Logger&quot; Elixir&#39;s Logger &quot;memory&quot; (Useful for testing) &quot;file_name.log&quot;","ref":"NewRelic.Config.html#logger/0","title":"NewRelic.Config.logger/0","type":"function"},{"doc":"NewRelic.Telemetry.Ecto provides Ecto instrumentation via telemetry. Repos are auto-discovered and instrumented. Make sure your Ecto app depends on new_relic_agent so that the agent can detect when your Repos start. We automatically gather: Datastore metrics Transaction Trace segments Transaction datastore attributes Distributed Trace span events You can opt-out of this instrumentation as a whole and specifically of SQL query collection via configuration. See NewRelic.Config for details.","ref":"NewRelic.Telemetry.Ecto.html","title":"NewRelic.Telemetry.Ecto","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"NewRelic.Telemetry.Ecto.html#child_spec/1","title":"NewRelic.Telemetry.Ecto.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"NewRelic.Telemetry.Ecto.html#init/1","title":"NewRelic.Telemetry.Ecto.init/1","type":"function"},{"doc":"","ref":"NewRelic.Telemetry.Ecto.html#start_link/1","title":"NewRelic.Telemetry.Ecto.start_link/1","type":"function"},{"doc":"Function Tracing To enable function tracing in a particular module, use NewRelic.Tracer, and annotate the functions you want to @trace. Traced functions will report as: Segments in Transaction Traces Span Events in Distributed Traces Special custom attributes on Transaction Events Notes: Traced functions will not be tail-call-recursive. Don&#39;t use this for recursive functions. Example defmodule MyModule do use NewRelic.Tracer @trace :func def func do # Will report as `MyModule.func/0` end end Categories To categorize External Service calls you must give the trace annotation a category. You may also call NewRelic.set_span to provide better naming for metrics &amp; spans, and additonally annotate the outgoing HTTP headers with the Distributed Tracing context to track calls across services. defmodule MyExternalService do use NewRelic.Tracer @trace {:request, category: :external} def request(method, url, headers) do NewRelic.set_span(:http, url: url, method: method, component: &quot;HttpClient&quot;) headers ++ NewRelic.distributed_trace_headers(:http) HttpClient.request(method, url, headers) end end This will: Post External metrics to APM Add custom attributes to Transaction events: external_call_count external_duration_ms external.MyExternalService.query.call_count external.MyExternalService.query.duration_ms Transactions that call the traced ExternalService functions will contain external_call_count attribute get &quot;/endpoint&quot; do ExternalService.request(:get, url, headers) send_resp(conn, 200, &quot;ok&quot;) end Arguments By default, arguments are inspected and recorded along with traces. You can opt-out of function argument tracing on individual tracers: defmodule SecretModule do use NewRelic.Tracer @trace {:login, args: false} def login(username, password) do # do something secret... end end This will prevent the argument values from becoming part of Transaction Traces. This may also be configured globally via Application config. See NewRelic.Config for details.","ref":"NewRelic.Tracer.html","title":"NewRelic.Tracer","type":"module"},{"doc":"Transaction Reporting To enable Transaction reporting, you must instrument your Plug pipeline with a single line. The NewRelic.Transaction macro injects the required plugs to wire up automatic Transaction reporting. Be sure to use this as early in your Plug pipeline as possible to ensure the most accurate response times. defmodule MyApp do use Plug.Router use NewRelic.Transaction # ... end To ignore reporting the current transaction, call: NewRelic.ignore_transaction() Inside a Transaction, the agent will track work across processes that are spawned as well as work done inside a Task Supervisor. When using Task.Supervisor.async_nolink you can signal to the agent not to track the work done inside the Task, which will exclude it from the current Transaction. To do this, send in an additional option: Task.Supervisor.async_nolink( MyTaskSupervisor, fn -&gt; do_work() end, new_relic: :no_track )","ref":"NewRelic.Transaction.html","title":"NewRelic.Transaction","type":"module"},{"doc":"If you send a custom error response in your own Plug.ErrorHandler, you MUST manually alert the agent of the error! defmodule MyPlug do # ... use Plug.ErrorHandler def handle_errors(conn, error) do NewRelic.Transaction.handle_errors(conn, error) send_resp(conn, 500, &quot;Oops!&quot;) end end","ref":"NewRelic.Transaction.html#handle_errors/2","title":"NewRelic.Transaction.handle_errors/2","type":"function"},{"doc":"New Relic&#39;s Open Source Elixir Agent The Open-Source Elixir Agent allows you to monitor your Elixir applications with New Relic. It helps you track transactions, distributed traces and other parts of your application&#39;s behavior and provides an overview of underlying BEAM activity. View the Documentation Support Statement New Relic has open-sourced this project to enable monitoring of Elixir applications. This project is provided AS-IS WITHOUT WARRANTY OR SUPPORT, although you can report issues and contribute to the project here on GitHub. Contributing We&#39;d love to get your contributions to improve the elixir agent! Keep in mind when you submit your pull request, you&#39;ll need to sign the CLA via the click-through using CLA-Assistant. If you&#39;d like to execute our corporate CLA, or if you have any questions, please drop us an email at open-source@newrelic.com.","ref":"readme.html","title":"New Relic&#39;s Open Source Elixir Agent","type":"extras"},{"doc":"Install the Hex package Requirements: Erlang/OTP 21 Elixir 1.8 defp deps do [ {:new_relic_agent, &quot;~&gt; 1.0&quot;} ] end","ref":"readme.html#installation","title":"New Relic&#39;s Open Source Elixir Agent - Installation","type":"extras"},{"doc":"You need to set a few required configuration keys so we can authenticate properly. Via Application config config :new_relic_agent, app_name: &quot;My App&quot;, license_key: &quot;license_key&quot; Via Environment variables You can also configure these attributes via ENV vars, which helps keep secrets out of source code. NEW_RELIC_APP_NAME NEW_RELIC_LICENSE_KEY","ref":"readme.html#configuration","title":"New Relic&#39;s Open Source Elixir Agent - Configuration","type":"extras"},{"doc":"Out of the box, we will report Error Traces &amp; some general BEAM VM stats. For further visibility, you&#39;ll need to add some basic instrumentation. Telemetry Some Elixir packages are auto-instrumented via telemetry Ecto: See NewRelic.Telemetry.Ecto for details. Plug Plug instrumentation is built into the agent. NewRelic.Transaction enables rich Transaction Monitoring for a Plug pipeline. It&#39;s a macro that injects a few plugs and an error handler. Install it by adding use NewRelic.Transaction to your Plug module. defmodule MyPlug do use Plug.Router use NewRelic.Transaction # ... end Tracing NewRelic.Tracer enables detailed Function tracing. Annotate a function and it&#39;ll show up as a span in Transaction Traces / Distributed Traces, and we&#39;ll collect aggregate stats about it. Install it by adding use NewRelic.Tracer to any module, and annotating any function with @trace module attribute defmodule MyModule do use NewRelic.Tracer @trace :func def func do # Will report as `MyModule.func/0` end end NewRelic.Tracer also enables detailed External request tracing. A little more instrumentation is required to pass the trace context forward with Distributed Tracing. defmodule MyExternalService do use NewRelic.Tracer @trace {:request, category: :external} def request(method, url, headers) do NewRelic.set_span(:http, url: url, method: method, component: &quot;HttpClient&quot;) headers ++ NewRelic.distributed_trace_headers(:http) HttpClient.request(method, url, headers) end end Mix.Task To enable the agent during a Mix.Task, you simply need to start and stop it. defmodule Mix.Tasks.Example do use Mix.Task def run(args) do Application.ensure_all_started(:new_relic_agent) # ... Application.stop(:new_relic_agent) end end Pre-Instrumented Modules NewRelic.Instrumented.HTTPoison Automatically wraps HTTP calls in a span, and adds an outbound header to track the request as part of a Distributed Trace. alias NewRelic.Instrumented.HTTPoison HTTPoison.get(&quot;http://www.example.com&quot;) Adapters There are a few adapters which leverage this agent to provide library / framework specific instrumentation: Phoenix https://github.com/binaryseed/new_relic_phoenix Absinthe https://github.com/binaryseed/new_relic_absinthe","ref":"readme.html#instrumentation","title":"New Relic&#39;s Open Source Elixir Agent - Instrumentation","type":"extras"},{"doc":"","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"v1.18.0 Features Read the Docker container ID for accurate container detection. #207 Thanks @alejandrodnm! Report Ecto queries that result in an error. #202 Coerce and handle all custom attribute values. #205 Tweaks Make plug_cowboy an optional dep. #201 Use Erlang/OTP 21+ built-in SSL hostname verification. #197 v1.17.1 Fixes Handle cases where another New Relic agent sends a bad tracestate header. #206 v1.17.0 Features Report &quot;Scoped&quot; Transaction metrics: Externals #175 Function traces #189 Database calls #195 Enable disabling function argument tracing globally &amp; per-trace. #186 Provide an API for manually stopping an Other transaction. #198 v1.16.7 Fixes Handle Ecto stream telemetry results. #192 v1.16.6 Fixes Prevent boot process from getting blocked if New Relic is slow. #187 v1.16.5 Fixes Fix macro compilation with Elixir 1.10. Thanks @ethangunderson! #185 v1.16.4 Tweaks Remove ecto metadata catchall for better debugging. v1.16.3 Fixes Fix sampling decision default value. #177 v1.16.2 Fixes Handle error queries properly. #173 v1.16.1 Fixes Safely access optional Ecto config attributes. #172 v1.16.0 Features Support the W3C Trace Context spec for Distributed Tracing. #169 Upgrade to New Relic &quot;Protocol 17&quot; which includes support for faster event harvest (sent every 5 seconds!). #168 v1.15.0 Features Adds automatic Ecto instrumentation via telemetry. #161 Deprecates @trace {_, category: :datastore}. These trace annotations will now be ignored, and a warning logged during compilation. Metric name change: Datastore Metrics reported now follow New Relic naming conventions, based on the table name v1.14.0 Features Minor internal refactor to enable reporting spans after they complete. #160 v1.13.1 Fixes Handle rare edge cases connecting to New Relic. #156 v1.13.0 Features OTP 21+ has been required for a while, and now the agent will enforce this version requirement #151 Truncate super large nested attribute structure #153 v1.12.0 Features Add support for detecting request queuing via x-request-start. #143 Thanks @sb8244! https://docs.newrelic.com/docs/apm/applications-menu/features/configure-request-queue-reporting v1.11.0 Features Add support for detecting if the app is running inside Kubernetes. #140 v1.10.2 Fixes Protect against huge arguments blowing out memory #136 v1.10.1 Tweaks Handle lists inside objects passed to add_attributes#135 Thanks @emeryotopalik! v1.10.0 Features Add an option to not track async_nolink task as part of the Transaction. #123 Ignore extraneous Plug errors (ie: 400s). #125 Tweaks Improve formatting of ErlangError. #126 v1.9.12 Fixes Prevent a rare harvester leak. #124 v1.9.11 Fixes Protect against missing attribute under race condition. #120 v1.9.10 Fixes Revert async_nolink change. #119 v1.9.9 Fixes Fix a race condition around error reporting and async_nolink#118. Thanks @zoevkay! v1.9.8 Fixes Fix a bug causing extra spans to be reported #116 v1.9.7 Tweaks Improve formatting for EXIT errors #112 #113 v1.9.5 Tweaks Track CPU count. #110 v1.9.4 Fixes Fix a bug in PriorityQueue. #109 Thanks @jasondew! v1.9.3 Tweaks Lowers the log level for harvester output. #105 v1.9.2 Fixes Fix a error that can happen if required attributes aren&#39;t captured. #103 v1.9.1 Fixes Fix the transaction event name attribute. #100 v1.9.0 Features Use erlang&#39;s httpc client. #70 Calculate and report the Total Time in a Transaction. #98 Fixes Attempt to flush each harvester upon graceful shutdown. #94 Report External metrics based on transaction type. #99 v1.8.0 Features Enable ignoring a Transaction. #93 Track the number of processes spawned during a Transaction. #88 Fixes Handle error fetching AWS fargate metadata. #89 Avoid a compiler warning for some traced functions. #92 Prevent nested spans from duplicating attributes. #97 v1.7.0 Support for &quot;Other&quot; (non-web) Transactions. #84 Calculate and report Apdex metric. #87 v1.6.2 Improve error logging when encountering a bad DT payload v1.6.1 Clear up some deprecation warnings in Elixir 1.8.0 v1.6.0 Add support for applying labels. #79 Detect Heroku dyno hostnames. #80 Provide better error structure for wrapped exceptions. #78 v1.5.0 More flexible datastore metric reporting in prep for Ecto instrumentation. #76 v1.4.0 Support nested Function Tracers in Transaction Traces and Distributed Tracing. #58 v1.3.2 Specify Plug and Cowboy versions via plug_cowboy package. v1.3.1 Properly handle when no app name has been supplied. v1.3.0 Enable the NewRelic logger to use the Elixir Logger #67 Properly assign multiple app names #66. Log the collector method along with failed requests #65. v1.2.1 Fix a bug that caused a subset of Span Events to be sent even though the Transaction wasn&#39;t sampled #63 v1.2.0 Leverage the new Erlang :logger when running OTP 21 for improved Transaction / Error connecting #55 Record process memory &amp; reductions at the end of a Transaction #56 v1.1.0 Report as elixir. #19 APM now has first-class support for Elixir! Along with this agent upgrade, you will find the BEAM stats page availble with easy access to information about the VM, including Processes, Memory and Network. See https://github.com/newrelic/elixir_agent/wiki/BEAM-stats-page for more info. Note: I haven&#39;t followed semver very well, from now on I&#39;ll be bumping the minor version for each release of new features, and reserve the patch for bugfixes. v1.0.5 Report more Beam VM stats. #38, #46 Report process stats for top consuming processes. #41 Re-factor a few agent innards to enable transaction name and errors. v1.0.4 Enable configuring Error collection via :error_collector_enabled#36 (Thanks @sb8244) v1.0.3 Report basic CPU and Memory metrics #34 Report caller metrics to enable relationship generation Extend the timeout waiting for data to post to New Relic Add HTTPoison.request/5 instrumented function (Thanks @rhruiz)","ref":"changelog.html#changelog","title":"CHANGELOG - CHANGELOG","type":"extras"}]